//////////////////////////////////////////////////////////////////////////////////
//                                                                              
// HMGSCRIPT: Programming For The Web in The Right Way :)
//                                                                              
//////////////////////////////////////////////////////////////////////////////////
// 
// I've wrote this library after analize tens of JavaScript samples, code,  
// tutorials and users posts in forums, freely available on the web.
// 
// I've simply attempted to arrange in a simple way, the common knowledge
// available about how to create modal windows and controls on the fly using
// JavaScript.
//
// So, I not consider this code as mine, then, I'm publishing it as public domain.
//
// From the user's perspective, these GUI functions should be as easy to use as
// HMG GUI commands and I've wrote them with such goal in mind.
//
// This library must be considered as pre-alpha.
//
//////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////
//
// This is free and unencumbered software released into the public domain.
// 
// Anyone is free to copy, modify, publish, use, compile, sell, or
// distribute this software, either in source code form or as a compiled
// binary, for any purpose, commercial or non-commercial, and by any
// means.
// 
// In jurisdictions that recognize copyright laws, the author or authors
// of this software dedicate any and all copyright interest in the
// software to the public domain. We make this dedication for the benefit
// of the public at large and to the detriment of our heirs and
// successors. We intend this dedication to be an overt act of
// relinquishment in perpetuity of all present and future rights to this
// software under copyright law.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
// 
// For more information, please refer to <http://unlicense.org/>
//
//////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////
// Window 
//////////////////////////////////////////////////////////////////////////////////
   
function Window( cId , cCaption , nWidth , nHeight )
{

   // Create a div for the cover, set its properties and add to the page body.
   // The cover is used since this is a modal window.
   	  
   var cover          = document.createElement( "div" )                             ;
   cover.className    = "cover"                                                     ;
   cover.style.width  = document.body.clientWidth                                   ;
   cover.style.height = document.body.clientHeight                                  ;
   cover.id           = 'cover_' + cId                                              ;

   document.body.appendChild( cover )                                               ;

   // Create a div for the window, set its properties and add to the page body.

   var window          = document.createElement( "div" )                            ;
   window.className    = "window"                                                   ;
   window.innerHTML    = "<h1>" + cCaption + "</h1>"                                ;
   window.style.top    = ( document.body.clientHeight / 2 ) - ( nHeight / 2 )       ;
   window.style.left   = ( document.body.clientWidth / 2 ) - ( nWidth / 2 )         ;
   window.style.width  = nWidth                                                     ;
   window.style.height = nHeight                                                    ;
   window.id           = cId                                                        ;

   document.body.appendChild( window );
      	                   
}

function Release( cId )
{
	document.getElementById( 'cover_' + cId ).parentNode.removeChild( document.getElementById( 'cover_' + cId ) )
	document.getElementById( cId ).parentNode.removeChild( document.getElementById( cId ) )
}

//////////////////////////////////////////////////////////////////////////////////
// Button 
/////////////////////////////////////////////////////////////////////////////////

function Button( cId , cParentId , nRow , nCol , cCaption , cOnClick )
{

  // Create the button on the fly, set its properties and append to the specified
  // parent window

   var control = document.createElement( "input" )      ;
      
   control.type           = "button"                    ;
   control.value          = cCaption                    ;
   control.onclick        = Function( cOnClick )        ;
   control.style.position = "absolute"                  ;
   control.style.top      = nRow                        ;
   control.style.left     = nCol                        ;
   control.style.width    = 120                         ;
   control.style.height   = 35                          ;
   control.id             = cId                         ;
    
   document.getElementById(cParentId).appendChild( control )                ;

}   

//////////////////////////////////////////////////////////////////////////////////
// Label 
//////////////////////////////////////////////////////////////////////////////////

function Label( cId , cParentId , nRow , nCol , cValue )
{

  // Create the label on the fly, set its properties and append to the specified
  // parent window

   var control = document.createElement( "span" );
      
   control.className      = "label"    ;
   control.style.top      = nRow       ;
   control.style.left     = nCol       ;
   control.innerHTML      = cValue     ;
   control.id             = cId        ;
      
   document.getElementById(cParentId).appendChild( control )                ;

}   

//////////////////////////////////////////////////////////////////////////////////
// TextBox
//////////////////////////////////////////////////////////////////////////////////


function TextBox( cId , cParentId , nRow , nCol , cValue )
{

  // Create the TextBox on the fly, set its properties and append to the specified
  // parent window

   var control = document.createElement( "input" );
   
   control.type           = "text"     ;
   control.className      = "textbox"  ;
   control.style.position = "absolute" ;
   control.style.top      = nRow       ;
   control.style.left     = nCol       ;
   control.value          = cValue     ;
   control.id             = cId        ;
      
   document.getElementById(cParentId).appendChild( control )                ;

}   

//////////////////////////////////////////////////////////////////////////////////
// Image
//////////////////////////////////////////////////////////////////////////////////

function Image( cId , cParentId , nRow , nCol , cSrc )
{

  // Create the Image on the fly, set its properties and append to the specified
  // parent window

   var control = document.createElement( "img" )                          ;            
      
   control.style.position = "absolute"                                      ;
   control.className      = "image"                                         ;
   control.id             = cId                                             ;
   control.style.top      = nRow                                            ;
   control.style.left     = nCol                                            ;
   control.src            = cSrc                                            ;
      
   document.getElementById(cParentId).appendChild( control )                ;

}   

//////////////////////////////////////////////////////////////////////////////////
// MsgInfo
//////////////////////////////////////////////////////////////////////////////////

function MsgInfo( cMessage , cCaption )
{
   Window( 'msginfowin' , cCaption , 300 , 150 );
   Label( 'msgi_label' , 'msginfowin' , 60 , 150 - ( cMessage.length * 2.3 ) , cMessage );
   Button( 'msgi_button' , 'msginfowin' , 100 , 100 , "Ok" , "Release('msginfowin')" );  
}


